<div class="mlQuestionText">
<p>
  Zadana je funkcija \(f(A,B,C) = \bar A B + \bar B\). Potrebno je označiti zaokruženja koja odgovaraju toj funkciji.
</p>
<p>
  Kada kliknete na ćeliju, označit će se plavom bojom. Moguće je označiti više ćelija. Kada
  ste označili željene ćelije, kliknite na gumb <i>Dodaj zaokruženje</i> kako biste zaokružili označenu grupu.
  Postupak ponovite za novo zaokruženje.
<br/>
Ako mislite da ste krivo odredili zaokruženje, možete ga ukloniti klikom na <i>Ukloni posljednje zaokruženje</i>.
</p>
<p>
  Jednom kada ste sigurni u sva zaokruženja, kliknite na gumb za nastavak.
</p>

<script>
@#page-include#(util.js)
@#page-include#(cellStateDrawer.js)
@#page-include#(cell.js)
@#page-include#(color.js)
@#page-include#(group.js)
@#page-include#(kmap.js)
</script>

<div style="text-align: center;">
  <button type="button" name="button" id="addCircle" class="btn btn-primary">Dodaj zaokruženje</button>
  <button type="button" name="button" id="undoCircle" class="btn btn-default">Ukloni posljednje zaokruženje</button>
</div>
<br>
<div style="text-align: center;">
  <canvas id="kmapCanvas"  width="500" height="300" style="border: solid 1px black"></canvas><br>
  <span class="mlSimAuthor">Autori simulacije: Arijana Brlek, Nino Uzelac</span>
</div>


<script>
  var canvas = document.getElementById("kmapCanvas");
  var context = canvas.getContext("2d");

  var konfiguracija = @#raw-text#(jsinitdata);
  var state = {
    leftVariables: konfiguracija.leftVariables,
    upperVariables: konfiguracija.upperVariables,
    elements: konfiguracija.elems,
    userInput: konfiguracija.userInput,
    showOrder: false,
    isGroupEditable: true,
    multiCellSelect: true,
    groups: konfiguracija.userInput.length > 0 ? konfiguracija.userInput.map(function(implicants) { return new Group(implicants); }) : []
  };

  var map = new KMap(state, context);
  map.draw(canvas, context);
  map.encircleGroups();

  canvas.addEventListener('mousedown', function(evt) {
    var rect = canvas.getBoundingClientRect();
    var pos = new Point(evt.clientX - rect.left, evt.clientY - rect.top);

    for(var i = 0; i < map.positions.length; i++) {
      for(var j = 0; j < map.positions[i].length; ++j) {
        var p = map.positions[i][j];
        if(pos.x >= p.x && pos.x < p.x + p.size && pos.y >= p.y && pos.y < p.y + p.size) {
            map.cellClick(p);
            map.reset(canvas, context);
            map.draw(canvas, context);
            map.encircleGroups();
            break;
        }
      }
    }
  }, false);

  jQuery('#addCircle').click(function(e) {
    var group = new Group(map.selectedImplicants);
    if(!group.isValid(map.variables.length, map.elements)) {
      alert("Zaokruženje nije legalno!");
      return;
    }

    map.addCircle();
    map.reset(canvas, context);
    map.draw(canvas, context);
    map.encircleGroups();
  });

  jQuery('#undoCircle').click(function(e) {
    if(map.groups.length > 0) {
      map.groups.splice(-1, 1);
      map.reset(canvas, context);
      map.draw(canvas, context);
      map.encircleGroups();
    }
  });


function questionCollectUserData() {
  return { userInput: map.groups.map(function(group) { return group.implicants; }) };
}
</script>

</div>
